org.apache.lucene.classification

## Class BM25NBClassifier

- java.lang.Object
- - org.apache.lucene.classification.BM25NBClassifier

- All Implemented Interfaces:
    Classifier<BytesRef>

      public class BM25NBClassifier
      extends Object
      implements Classifier<BytesRef>

  A classifier approximating naive bayes classifier by using pure queries on BM25.
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BM25NBClassifier(IndexReader indexReader, Analyzer analyzer, Query query, String classFieldName, String... textFieldNames)` Creates a new NaiveBayes classifier.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ClassificationResult<BytesRef>` | `assignClass(String inputDocument)` Assign a class (with score) to the given text String
    `List<ClassificationResult<BytesRef>>` | `getClasses(String text)` Get all the classes (sorted by score, descending) assigned to the given text String.
    `List<ClassificationResult<BytesRef>>` | `getClasses(String text, int max)` Get the first `max` classes (sorted by score, descending) assigned to the given text String.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BM25NBClassifier

          public BM25NBClassifier(IndexReader indexReader,
                                  Analyzer analyzer,
                                  Query query,
                                  String classFieldName,
                                  String... textFieldNames)

      Creates a new NaiveBayes classifier.
      Parameters:
        `indexReader` - the reader on the index to be used for classification
        `analyzer` - an `Analyzer` used to analyze unseen text
        `query` - a `Query` to eventually filter the docs used for training the classifier, or `null` if all the indexed docs should be used
        `classFieldName` - the name of the field used as the output for the classifier NOTE: must not be heavely analyzed as the returned class will be a token indexed for this field
        `textFieldNames` - the name of the fields used as the inputs for the classifier, NO boosting supported per field

  - ### Method Detail

    - #### assignClass

          public ClassificationResult<BytesRef> assignClass(String inputDocument)
                                                     throws IOException

      Description copied from interface: `Classifier`
      Assign a class (with score) to the given text String
      Specified by:
        `assignClass` in interface `Classifier<BytesRef>`
      Parameters:
        `inputDocument` - a String containing text to be classified
      Returns:
        a `ClassificationResult` holding assigned class of type `T` and score
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### getClasses

          public List<ClassificationResult<BytesRef>> getClasses(String text)
                                                          throws IOException

      Description copied from interface: `Classifier`
      Get all the classes (sorted by score, descending) assigned to the given text String.
      Specified by:
        `getClasses` in interface `Classifier<BytesRef>`
      Parameters:
        `text` - a String containing text to be classified
      Returns:
        the whole list of `ClassificationResult`, the classes and scores. Returns `null` if the classifier can't make lists.
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### getClasses

          public List<ClassificationResult<BytesRef>> getClasses(String text,
                                                                 int max)
                                                          throws IOException

      Description copied from interface: `Classifier`
      Get the first `max` classes (sorted by score, descending) assigned to the given text String.
      Specified by:
        `getClasses` in interface `Classifier<BytesRef>`
      Parameters:
        `text` - a String containing text to be classified
        `max` - the number of return list elements
      Returns:
        the whole list of `ClassificationResult`, the classes and scores. Cut for "max" number of elements. Returns `null` if the classifier can't make lists.
      Throws:
        `IOException` - If there is a low-level I/O error.

Copyright © 2000-2019 Apache Software Foundation. All Rights Reserved.